Index: /codes/icosagcm/trunk/src/write_field.f90
===================================================================
--- /codes/icosagcm/trunk/src/write_field.f90	(revision 38)
+++ /codes/icosagcm/trunk/src/write_field.f90	(revision 39)
@@ -1167,6 +1167,6 @@
         status = NF90_CREATE(TRIM(ADJUSTL(name))//'.nc', NF90_CLOBBER, ncid)
         FieldId(NbField)=ncid
-        status = NF90_DEF_DIM(ncid,'cell',ncell,ncellId)
-        status = NF90_DEF_DIM(ncid,'nvert',nvert,nvertid)
+        status = NF90_DEF_DIM(ncid,'cell_i',ncell,ncellId)
+        status = NF90_DEF_DIM(ncid,'nvert_i',nvert,nvertid)
 
         IF (Field(ind_b)%ndim==2)  THEN
@@ -1186,26 +1186,26 @@
         status = NF90_DEF_DIM(ncid,'time_counter',NF90_UNLIMITED,timeId)
       
-        status = NF90_DEF_VAR(ncid,'lon',NF90_DOUBLE,(/ ncellId /),lonId)
+        status = NF90_DEF_VAR(ncid,'lon_i',NF90_DOUBLE,(/ ncellId /),lonId)
         status = NF90_PUT_ATT(ncid,lonId,"long_name","longitude")
         status = NF90_PUT_ATT(ncid,lonId,"units","degrees_east")
-        status = NF90_PUT_ATT(ncid,lonId,"bounds","bounds_lon")
-        status = NF90_DEF_VAR(ncid,'lat',NF90_DOUBLE,(/ ncellId /),latId)
+        status = NF90_PUT_ATT(ncid,lonId,"bounds","bounds_lon_i")
+        status = NF90_DEF_VAR(ncid,'lat_i',NF90_DOUBLE,(/ ncellId /),latId)
         status = NF90_PUT_ATT(ncid,latId,"long_name","latitude")
         status = NF90_PUT_ATT(ncid,latId,"units","degrees_north")
-        status = NF90_PUT_ATT(ncid,latId,"bounds","bounds_lat")
-        status = NF90_DEF_VAR(ncid,'bounds_lon',NF90_DOUBLE,(/ nvertid,ncellId /),bounds_lonId)
-        status = NF90_DEF_VAR(ncid,'bounds_lat',NF90_DOUBLE,(/ nvertid,ncellId /),bounds_latId)
+        status = NF90_PUT_ATT(ncid,latId,"bounds","bounds_lat_i")
+        status = NF90_DEF_VAR(ncid,'bounds_lon_i',NF90_DOUBLE,(/ nvertid,ncellId /),bounds_lonId)
+        status = NF90_DEF_VAR(ncid,'bounds_lat_i',NF90_DOUBLE,(/ nvertid,ncellId /),bounds_latId)
 
         IF (Field(ind_b)%ndim==2) THEN
           status = NF90_DEF_VAR(ncid,TRIM(ADJUSTL(name)),NF90_DOUBLE,(/ ncellId,timeId /),FieldVarId(NbField)%nc_id(1))
-          status = NF90_PUT_ATT(ncid,FieldVarId(NbField)%nc_id(1),"coordinates","lon lat")
+          status = NF90_PUT_ATT(ncid,FieldVarId(NbField)%nc_id(1),"coordinates","lon_i lat_i")
         ELSE IF (Field(ind_b)%ndim==3) THEN
           status = NF90_DEF_VAR(ncid,TRIM(ADJUSTL(name)),NF90_DOUBLE,(/ ncellId,dim3id,timeId /),FieldVarId(NbField)%nc_id(1))
-          status = NF90_PUT_ATT(ncid,FieldVarId(NbField)%nc_id(1),"coordinates","lon lat")
+          status = NF90_PUT_ATT(ncid,FieldVarId(NbField)%nc_id(1),"coordinates","lon_i lat_i")
         ELSE IF (Field(ind_b)%ndim==4) THEN
           DO i=1,FieldVarId(NbField)%size
             status = NF90_DEF_VAR(ncid,TRIM(ADJUSTL(name))//int2str(i),NF90_DOUBLE,(/ ncellId,dim3id,timeId /),  &
                                   FieldVarId(NbField)%nc_id(i))
-            status = NF90_PUT_ATT(ncid,FieldVarId(NbField)%nc_id(i),"coordinates","lon lat")
+            status = NF90_PUT_ATT(ncid,FieldVarId(NbField)%nc_id(i),"coordinates","lon_i lat_i")
           ENDDO        
         ENDIF 
@@ -1276,6 +1276,6 @@
         status = NF90_CREATE(TRIM(ADJUSTL(name))//'.nc', NF90_CLOBBER, ncid)
         FieldId(NbField)=ncid
-        status = NF90_DEF_DIM(ncid,'cell',ncell,ncellId)
-        status = NF90_DEF_DIM(ncid,'nvert',nvert,nvertid)
+        status = NF90_DEF_DIM(ncid,'cell_v',ncell,ncellId)
+        status = NF90_DEF_DIM(ncid,'nvert_v',nvert,nvertid)
 
         IF (Field(ind_b)%ndim==2)  THEN
@@ -1296,27 +1296,27 @@
         status = NF90_DEF_DIM(ncid,'time_counter',NF90_UNLIMITED,timeId)
       
-        status = NF90_DEF_VAR(ncid,'lon',NF90_DOUBLE,(/ ncellId /),lonId)
+        status = NF90_DEF_VAR(ncid,'lon_v',NF90_DOUBLE,(/ ncellId /),lonId)
         status = NF90_PUT_ATT(ncid,lonId,"long_name","longitude")
         status = NF90_PUT_ATT(ncid,lonId,"units","degrees_east")
-        status = NF90_PUT_ATT(ncid,lonId,"bounds","bounds_lon")
-        status = NF90_DEF_VAR(ncid,'lat',NF90_DOUBLE,(/ ncellId /),latId)
+        status = NF90_PUT_ATT(ncid,lonId,"bounds","bounds_lon_v")
+        status = NF90_DEF_VAR(ncid,'lat_v',NF90_DOUBLE,(/ ncellId /),latId)
         status = NF90_PUT_ATT(ncid,latId,"long_name","latitude")
         status = NF90_PUT_ATT(ncid,latId,"units","degrees_north")
-        status = NF90_PUT_ATT(ncid,latId,"bounds","bounds_lat")
-        status = NF90_DEF_VAR(ncid,'bounds_lon',NF90_DOUBLE,(/ nvertid,ncellId /),bounds_lonId)
-        status = NF90_DEF_VAR(ncid,'bounds_lat',NF90_DOUBLE,(/ nvertid,ncellId /),bounds_latId)
+        status = NF90_PUT_ATT(ncid,latId,"bounds","bounds_lat_v")
+        status = NF90_DEF_VAR(ncid,'bounds_lon_v',NF90_DOUBLE,(/ nvertid,ncellId /),bounds_lonId)
+        status = NF90_DEF_VAR(ncid,'bounds_lat_v',NF90_DOUBLE,(/ nvertid,ncellId /),bounds_latId)
 
 
         IF (Field(ind_b)%ndim==2) THEN
           status = NF90_DEF_VAR(ncid,TRIM(ADJUSTL(name)),NF90_DOUBLE,(/ ncellId,timeId /),FieldVarId(NbField)%nc_id(1))
-          status = NF90_PUT_ATT(ncid,FieldVarId(NbField)%nc_id(1),"coordinates","lon lat")
+          status = NF90_PUT_ATT(ncid,FieldVarId(NbField)%nc_id(1),"coordinates","lon_v lat_v")
         ELSE IF (Field(ind_b)%ndim==3) THEN
           status = NF90_DEF_VAR(ncid,TRIM(ADJUSTL(name)),NF90_DOUBLE,(/ ncellId,dim3id,timeId /),FieldVarId(NbField)%nc_id(1))
-          status = NF90_PUT_ATT(ncid,FieldVarId(NbField)%nc_id(1),"coordinates","lon lat")
+          status = NF90_PUT_ATT(ncid,FieldVarId(NbField)%nc_id(1),"coordinates","lon_v lat_v")
         ELSE IF (Field(ind_b)%ndim==4) THEN
           DO q=1,FieldVarId(NbField)%size
             status = NF90_DEF_VAR(ncid,TRIM(ADJUSTL(name)//int2str(q)),NF90_DOUBLE,             &
                                   (/ ncellId,dim3id,timeId /),FieldVarId(NbField)%nc_id(q))
-            status = NF90_PUT_ATT(ncid,FieldVarId(NbField)%nc_id(q),"coordinates","lon lat")
+            status = NF90_PUT_ATT(ncid,FieldVarId(NbField)%nc_id(q),"coordinates","lon_v lat_v")
           ENDDO        
         ENDIF 